# roccclient
The OpenAPI specification implemented by the Challenge Registries.
# Introduction
TBA


This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://Sage-Bionetworks.github.io/rocc-schemas](https://Sage-Bionetworks.github.io/rocc-schemas)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import roccclient
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import roccclient
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function

import time
import roccclient
from roccclient.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://rocc.com/api.dev/v1
# See configuration.py for a list of all supported configuration parameters.
configuration = roccclient.Configuration(
    host = "https://rocc.com/api.dev/v1"
)



# Enter a context with an instance of the API client
with roccclient.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = roccclient.ChallengeApi(api_client)
    challenge = roccclient.Challenge() # Challenge | 

    try:
        # Add a challenge
        api_response = api_instance.create_challenge(challenge)
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ChallengeApi->create_challenge: %s\n" % e)
    
```

## Documentation for API Endpoints

All URIs are relative to *https://rocc.com/api.dev/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ChallengeApi* | [**create_challenge**](docs/ChallengeApi.md#create_challenge) | **POST** /challenges | Add a challenge
*ChallengeApi* | [**delete_challenge**](docs/ChallengeApi.md#delete_challenge) | **DELETE** /challenges/{id} | Delete a challenge
*ChallengeApi* | [**get_challenge**](docs/ChallengeApi.md#get_challenge) | **GET** /challenges/{id} | Get a challenge
*ChallengeApi* | [**list_challenges**](docs/ChallengeApi.md#list_challenges) | **GET** /challenges | List all the challenges
*UserApi* | [**get_user_by_name**](docs/UserApi.md#get_user_by_name) | **GET** /users/{username} | Get user by user name


## Documentation For Models

 - [Challenge](docs/Challenge.md)
 - [Error](docs/Error.md)
 - [Grant](docs/Grant.md)
 - [Organization](docs/Organization.md)
 - [PageOfChallenges](docs/PageOfChallenges.md)
 - [PageOfChallengesAllOf](docs/PageOfChallengesAllOf.md)
 - [Person](docs/Person.md)
 - [ResponsePageMetadata](docs/ResponsePageMetadata.md)
 - [ResponsePageMetadataLinks](docs/ResponsePageMetadataLinks.md)
 - [User](docs/User.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

thomas.schaffter@sagebionetworks.org


